<?php
function _coreUpdate()
{
	global $objDatabase, $_CONFIG, $objUpdate, $_ARRAYLANG, $_DBCONFIG, $_CORELANG;

	$query = "SELECT `id` FROM `".DBPREFIX."languages` WHERE `charset` != 'UTF-8'";
	$objLanguage = $objDatabase->Execute($query);
	if ($objLanguage !== false) {
		while (!$objLanguage->EOF) {
			$query = "UPDATE `".DBPREFIX."languages` SET `charset` = 'UTF-8' WHERE `id`=".$objLanguage->fields['id'];
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
			$objLanguage->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."access_users");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'access_users konnte nicht ermittelt werden!'));
		return false;
	}

	$query = "ALTER TABLE `".DBPREFIX."access_users`
		CHANGE `residence` `residence` varchar(255) NOT NULL default '',
		CHANGE `profession` `profession` varchar(255) NOT NULL default '',
		CHANGE `interests` `interests` varchar(255) NOT NULL default '',
		CHANGE `webpage` `webpage` varchar(255) NOT NULL default '',
		CHANGE `restore_key` `restore_key` varchar(32) NOT NULL default '',
		CHANGE `restore_key_time` `restore_key_time` int(14) unsigned NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."content`
		CHANGE `metatitle` `metatitle` varchar(250) NOT NULL default '',
		CHANGE `css_name` `css_name` varchar(50) NOT NULL default ''";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."content_logfile`
		CHANGE `history_id` `history_id` int(10) unsigned NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."sessions` CHANGE `datavalue` `datavalue` text NULL";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."content_navigation`
		CHANGE `frontend_access_id` `frontend_access_id` int(11) unsigned NOT NULL default '0',
  		CHANGE `backend_access_id` `backend_access_id` int(11) unsigned NOT NULL default '0',
  		CHANGE `themes_id` `themes_id` int(4) NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	if (!in_array('company', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` ADD `company` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `webpage`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."access_users` CHANGE `company` `company` VARCHAR( 255 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('zip', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` ADD `zip` VARCHAR( 10 ) NOT NULL DEFAULT '' AFTER `company`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."access_users` CHANGE `zip` `zip` VARCHAR( 10 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('phone', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` ADD `phone` VARCHAR( 20 ) NOT NULL DEFAULT '' AFTER `zip`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."access_users` CHANGE `phone` `phone` VARCHAR( 20 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('mobile', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` ADD `mobile` VARCHAR( 20 ) NOT NULL DEFAULT '' AFTER `phone`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."access_users` CHANGE `mobile` `mobile` VARCHAR( 20 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('street', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` ADD `street` VARCHAR( 100 ) NOT NULL  DEFAULT '' AFTER `mobile`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."access_users` CHANGE `street` `street` VARCHAR( 100 ) NOT NULL  DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (in_array('birthday', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` DROP `birthday`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (in_array('show_birthday', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."access_users` DROP `show_birthday`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "ALTER TABLE `".DBPREFIX."access_group_dynamic_ids` CHANGE `access_id` `access_id` int(11) unsigned NOT NULL default '0',
		 CHANGE `group_id` `group_id` int(11) unsigned NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."access_group_static_ids` CHANGE `access_id` `access_id` int(11) unsigned NOT NULL default '0',
		 CHANGE `group_id` `group_id` int(11) unsigned NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// pdfview
	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."languages");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'languages konnte nicht ermittelt werden!'));
		return false;
	}
	if (!in_array('pdf_themes_id', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."languages` ADD `pdf_themes_id` INT( 2 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `print_themes_id`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT count(*) as PDFtheme FROM `".DBPREFIX."skins` WHERE `themesname` = 'pdf' AND `foldername` = 'pdf'";
	$objContent = $objDatabase->Execute($query);
	if ($objContent !== false) {
		if($objContent->fields['PDFtheme']<1){
			$query = "INSERT INTO ".DBPREFIX."skins (`themesname`, `foldername`, `expert`) VALUES ('pdf', 'pdf', 1)";
			if ($objDatabase->Execute($query) !== false) {
				$skinId = $objDatabase->Insert_ID();

				$query = "SELECT count(*) as PDFskin FROM `".DBPREFIX."languages` WHERE `pdf_themes_id` != 0";
				$objContent = $objDatabase->Execute($query);
				if ($objContent->fields['PDFskin']<1) {
					$objDatabase->Execute("UPDATE ".DBPREFIX."languages SET pdf_themes_id = ".$skinId);
				}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// update workflow
	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."content_logfile");
	if ($arrIndexes === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'content_logfile'));
		return false;
	}

	if (!isset($arrIndexes['history_id'])) {
		$query = "ALTER TABLE `".DBPREFIX."content_logfile` ADD INDEX ( `history_id` )";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT `frontend_access_id`, `backend_access_id` FROM `".DBPREFIX."content_navigation` WHERE `frontend_access_id` != 0 OR `backend_access_id` != 0";
	$objContent = $objDatabase->Execute($query);
	if ($objContent) {
		$arrAccessIds = array();

		while (!$objContent->EOF) {
			if ($objContent->fields['frontend_access_id'] > 0) {
				array_push($arrAccessIds, $objContent->fields['frontend_access_id']);
			}
			if ($objContent->fields['backend_access_id'] > 0) {
				array_push($arrAccessIds, $objContent->fields['backend_access_id']);
			}
			$objContent->MoveNext();
		}

		$arrAccessIdCount = array_count_values($arrAccessIds);

		$query = "SELECT `setvalue` FROM `".DBPREFIX."settings` WHERE `setname` = 'lastAccessId'";
		$objSettings = $objDatabase->SelectLimit($query, 1);
		if ($objSettings) {
			if ($objSettings->RecordCount() == 1) {
				$lastRightId = $objSettings->fields['setvalue'];
			} else {
				setUpdateMsg($_ARRAYLANG['TXT_UNABLE_UPGRADE_ACCESS_SYSTEM']);
				return false;
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		$query = "SELECT
			MAX(tblNav.`frontend_access_id`) AS maxFN,
			MAX(tblNav.`backend_access_id`) AS maxBN,
			MAX(tblHistory.`frontend_access_id`) AS maxFH,
			MAX(tblHistory.`backend_access_id`) AS maxBH
			FROM `".DBPREFIX."content_navigation` AS tblNav,
			`".DBPREFIX."content_navigation_history` AS tblHistory";
		$objResult = $objDatabase->SelectLimit($query, 1);
		if ($objResult) {
			if ($objResult->RecordCount() > 0) {
				$arrLastRightId = array(
					$objResult->fields['maxFN'],
					$objResult->fields['maxBN'],
					$objResult->fields['maxFH'],
					$objResult->fields['maxBH']
				);
				if ($lastRightId < max($arrLastRightId)) {
					$lastRightId = max($arrLastRightId);
					$query = "UPDATE `".DBPREFIX."settings` SET `setvalue` = '".$lastRightId."' WHERE `setname` = 'lastAccessId'";
					if ($objDatabase->Execute($query) === false) {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		require_once ASCMS_FRAMEWORK_PATH.'/User.class.php';
		$objUser = &new FWUser();
		$arrGroups = $objUser->getGroups();
		if (!is_array($arrGroups)) {
			setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_AVAILABLE_GROUPS']);
			return false;
		}

		foreach ($arrAccessIdCount as $accessId => $count) {
			if ($count > 1) {
				// get associated groups
				$arrAssociatedGroups = array();
				$query = "SELECT `group_id` FROM `".DBPREFIX."access_group_dynamic_ids` WHERE `access_id` = ".$accessId;
				$objAccess = $objDatabase->Execute($query);
				if ($objAccess) {
					while (!$objAccess->EOF) {
						array_push($arrAssociatedGroups, $objAccess->fields['group_id']);
						$objAccess->MoveNext();
					}
					$arrAssociatedGroups = array_unique($arrAssociatedGroups);

					// get protected pages
					$query = "SELECT `catid`, `frontend_access_id`, `backend_access_id` FROM `".DBPREFIX."content_navigation` WHERE `frontend_access_id` = ".$accessId." OR `backend_access_id` = ".$accessId;
					$objContent = $objDatabase->Execute($query);
					if ($objContent) {
						while (!$objContent->EOF) {
							if ($objContent->fields['frontend_access_id'] > 0 && $arrAccessIdCount[$objContent->fields['frontend_access_id']] > 1) {
								$lastRightId++;

								$query = "SELECT 1 FROM `".DBPREFIX."content_navigation` WHERE `frontend_access_id` = ".$lastRightId." OR `backend_access_id` = ".$lastRightId;
								$objResult = $objDatabase->SelectLimit($query, 1);
								if ($objResult) {
									if ($objResult->RecordCount() == 1) {
										$lastRightId++;
									}
								} else {
									return _databaseError($query, $objDatabase->ErrorMsg());
								}

								$query = "UPDATE `".DBPREFIX."settings` SET `setvalue` = '".$lastRightId."' WHERE `setname` = 'lastAccessId'";
								if ($objDatabase->Execute($query) === false) {
									return _databaseError($query, $objDatabase->ErrorMsg());
								}

								$query = "UPDATE `".DBPREFIX."content_navigation` SET `frontend_access_id` = ".$lastRightId." WHERE `catid` = ".$objContent->fields['catid'];
								if ($objDatabase->Execute($query) === false) {
									return _databaseError($query, $objDatabase->ErrorMsg());
								}

								// don't check if the following query will be successful!
								$query = "UPDATE `".DBPREFIX."content_navigation_history` SET `frontend_access_id` = ".$lastRightId." WHERE `catid` = ".$objContent->fields['catid']." AND `frontend_access_id` = ".$accessId;
								$objDatabase->Execute($query);

								foreach ($arrAssociatedGroups as $groupId) {
									if ($arrGroups[$groupId]['type'] == 'frontend') {
										// don't check if the following query will be successful, because it is more important that this function continues than a group assiciation won't be applyed!
										$objDatabase->Execute("INSERT INTO `".DBPREFIX."access_group_dynamic_ids` (`access_id`, `group_id`) VALUES (".$lastRightId.", ".$groupId.")");
									}
								}
							}

							if ($objContent->fields['backend_access_id'] > 0 && $arrAccessIdCount[$objContent->fields['backend_access_id']] > 1) {
								$lastRightId++;

								$query = "SELECT 1 FROM `".DBPREFIX."content_navigation` WHERE `frontend_access_id` = ".$lastRightId." OR `backend_access_id` = ".$lastRightId;
								$objResult = $objDatabase->SelectLimit($query, 1);
								if ($objResult) {
									if ($objResult->RecordCount() == 1) {
										$lastRightId++;
									}
								} else {
									return _databaseError($query, $objDatabase->ErrorMsg());
								}

								$query = "UPDATE `".DBPREFIX."settings` SET `setvalue` = '".$lastRightId."' WHERE `setname` = 'lastAccessId'";
								if ($objDatabase->Execute($query) === false) {
									return _databaseError($query, $objDatabase->ErrorMsg());
								}

								$query = "UPDATE `".DBPREFIX."content_navigation` SET `backend_access_id` = ".$lastRightId." WHERE `catid` = ".$objContent->fields['catid'];
								if ($objDatabase->Execute($query) === false) {
									return _databaseError($query, $objDatabase->ErrorMsg());
								}

								// don't check if the following query will be successful!
								$query = "UPDATE `".DBPREFIX."content_navigation_history` SET `backend_access_id` = ".$lastRightId." WHERE `catid` = ".$objContent->fields['catid']." AND `backend_access_id` = ".$accessId;
								$objDatabase->Execute($query);

								foreach ($arrAssociatedGroups as $groupId) {
									if ($arrGroups[$groupId]['type'] == 'backend') {
										// don't check if the following query will be successful, because it is more important that this function continues than a group assiciation won't be applyed!
										$objDatabase->Execute("INSERT INTO `".DBPREFIX."access_group_dynamic_ids` (`access_id`, `group_id`) VALUES (".$lastRightId.", ".$groupId.")");
									}
								}
							}

							$objContent->MoveNext();
						}
					} else {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				} else {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}

				// don't check if the following query will be successful, because we won't either be able to execute it again!
				$objDatabase->Execute("DELETE FROM `".DBPREFIX."access_group_dynamic_ids` WHERE `access_id` = ".$accessId);
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT `catid` FROM `".DBPREFIX."content_navigation`";
	$objContentNavigation = $objDatabase->Execute($query);
	if ($objContentNavigation !== false) {
		$arrContentSiteIds = array();
		while (!$objContentNavigation->EOF) {
			array_push($arrContentSiteIds, $objContentNavigation->fields['catid']);
			$objContentNavigation->MoveNext();
		}

		$query = "DELETE FROM `".DBPREFIX."content` WHERE `id` != ".implode(' AND `id` != ', $arrContentSiteIds);
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// update content
	if ($objUpdate->_isNewerVersion($_CONFIG['coreCmsVersion'], '1.0.9.10')) {
		$arrModules = array();
		$query = "SELECT `id`, `name` FROM `".DBPREFIX."modules`";
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$arrModules[$objResult->fields['id']] = $objResult->fields['name'];
				$objResult->MoveNext();
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

    	$query = "
    		SELECT
	    		c.`id`,
	    		c.`content`,
	    		c.`title`,
	    		c.`metatitle`,
	    		c.`metadesc`,
	    		c.`metakeys`,
	    		c.`metarobots`,
	    		c.`css_name`,
	    		c.`redirect`,
	    		c.`expertmode`,
	    		n.`catid`,
	    		n.`parcat`,
	    		n.`catname`,
	    		n.`target`,
	    		n.`displayorder`,
	    		n.`displaystatus`,
	    		n.`cachingstatus`,
	    		n.`cmd`,
	    		n.`lang`,
	    		n.`module`,
	    		n.`startdate`,
	    		n.`enddate`,
	    		n.`protected`,
	    		n.`frontend_access_id`,
	    		n.`backend_access_id`,
	    		n.`themes_id`
    		FROM `".DBPREFIX."content` AS c
    		INNER JOIN `".DBPREFIX."content_navigation` AS n ON n.`catid` = c.`id`
    		WHERE n.`username` != 'sys_update'";
    	$objContent = $objDatabase->Execute($query);
    	if ($objContent !== false) {
    		$hasContact = false;
    		$arrFailedPages = array();
    		while (!$objContent->EOF) {
    			$query = "UPDATE
    				`".DBPREFIX."content` AS c INNER JOIN `".DBPREFIX."content_navigation` AS n ON n.`catid` = c.`id`
    			SET
    				c.`content` = '".addslashes(stripslashes($objContent->fields['content']))."',
    				c.`title` = '".$objContent->fields['title']."',
    				c.`metatitle` = '".$objContent->fields['metatitle']."',
    				c.`metadesc` = '".$objContent->fields['metadesc']."',
    				c.`metakeys` = '".$objContent->fields['metakeys']."',
    				c.`metarobots` = '".$objContent->fields['metarobots']."',
    				c.`css_name` = '".$objContent->fields['css_name']."',
    				c.`redirect` = '".$objContent->fields['redirect']."',
    				n.`catname` = '".$objContent->fields['catname']."',
    				n.`username` = 'sys_update',
    				n.`changelog` = ".time()."
    			WHERE
    				c.`id` = ".$objContent->fields['id'];
    			if ($objDatabase->Execute($query) === false) {
    				$s = isset($arrModules[$objContent->fields['module']]) ? $arrModules[$objContent->fields['module']] : '';
					$c = $objContent->fields['cmd'];
					$section = ($s=="") ? "" : "&amp;section=$s";
					$cmd = ($c=="") ? "" : "&amp;cmd=$c";

					switch ($s) {
						case 'gallery':
    						$query = "SELECT `id`, `catid` FROM `".DBPREFIX."module_gallery_pictures`";
    						$objGallery = $objDatabase->SelectLimit($query, 1);
    						if ($objGallery !== false) {
								if ($objGallery->RecordCount() == 1) {
									$s .= "&amp;cid=".$objGallery->fields['catid']."&amp;pId=".$objGallery->fields['id'];
								}
    						} else {
    							return _databaseError($query, $objDatabase->ErrorMsg());
							}
							break;

						case 'contact':
							$hasContact = true;
							break;

						default:
							break;
					}

					$link = (!empty($s)) ? "?section=".$s.$cmd : "?page=".$objContent->fields['catid'].$section.$cmd;
    				$arrFailedPages[$objContent->fields['id']] = array('title' => $objContent->fields['catname'], 'link' => '../index.php'.$link.'&amp;langId='.$objContent->fields['lang']);
    			} else {
	    			$objDatabase->Execute("UPDATE `".DBPREFIX."content_navigation_history` SET `is_active` = '0' WHERE `catid` = ".$objContent->fields['id']);
	    			$objDatabase->Execute("
	    				INSERT INTO `".DBPREFIX."content_navigation_history`
						SET
							`is_active` = '1',
							`catid` = ".$objContent->fields['id'].",
							`parcat` = ".$objContent->fields['parcat'].",
							`catname` = '".$objContent->fields['catname']."',
							`target` = '".$objContent->fields['target']."',
							`displayorder` = ".$objContent->fields['displayorder'].",
							`displaystatus` = '".$objContent->fields['displaystatus']."',
							`cachingstatus` = '".$objContent->fields['cachingstatus']."',
							`username` = 'sys_update',
							`changelog` = ".time().",
							`cmd` = '".$objContent->fields['cmd']."',
							`lang` = ".$objContent->fields['lang'].",
							`module` = ".$objContent->fields['module'].",
							`startdate` = '".$objContent->fields['startdate']."',
							`enddate` = '".$objContent->fields['enddate']."',
							`protected` = ".$objContent->fields['protected'].",
							`frontend_access_id` = ".$objContent->fields['frontend_access_id'].",
							`backend_access_id` = ".$objContent->fields['backend_access_id'].",
							`themes_id` = ".$objContent->fields['themes_id']
					);

					$historyId = $objDatabase->Insert_ID();

					$objDatabase->Execute("
						INSERT INTO `".DBPREFIX."content_history`
						SET
							`id` = ".$historyId.",
							`page_id` = ".$objContent->fields['id'].",
							`content` = '".addslashes(stripslashes($objContent->fields['content']))."',
							`title` = '".$objContent->fields['title']."',
							`metatitle` = '".$objContent->fields['metatitle']."',
							`metadesc` = '".$objContent->fields['metadesc']."',
							`metakeys` = '".$objContent->fields['metakeys']."',
							`metarobots` = '".$objContent->fields['metarobots']."',
							`css_name` = '".$objContent->fields['css_name']."',
							`redirect` = '".$objContent->fields['redirect']."',
							`expertmode` = '".$objContent->fields['expertmode']."'
					");

					$objDatabase->Execute("
						INSERT INTO	`".DBPREFIX."content_logfile`
						SET
							`action` = 'update',
							`history_id` = ".$historyId.",
							`is_validated` = '1'
					");
    			}

    			$objContent->MoveNext();
    		}

    		if (count($arrFailedPages)) {
    			setUpdateMsg($_ARRAYLANG['TXT_CHECK_CONTENT_PAGE_FOR_BUGS']);

        			$pages = '<ul>';
        			foreach ($arrFailedPages as $arrPage) {
        				$pages .= "<li><a href='".$arrPage['link']."' target='_blank'>".$arrPage['title']." (".$arrPage['link'].")</a></li>";
        			}
        			$pages .= '</ul>';
        			setUpdateMsg($pages);
    		}

    	} else {
    		return _databaseError($query, $objDatabase->ErrorMsg());
    	}
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX.'content_navigation');
	if ($arrIndexes === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'content_navigation'));
		return false;
	}

	if (isset($arrIndexes['catid'])) {
		$query = "ALTER TABLE `".DBPREFIX."content_navigation` DROP INDEX `catid`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	// add column css_name to content_navigation
	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."content_navigation");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'content_navigation'));
		return false;
	}
	if (!in_array('css_name', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."content_navigation` ADD `css_name` VARCHAR( 255 ) NOT NULL DEFAULT ''";
	} else {
		$query = "ALTER TABLE `".DBPREFIX."content_navigation` CHANGE `css_name` `css_name` VARCHAR( 255 ) NOT NULL DEFAULT ''";
	}
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."content_navigation_history");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'content_navigation_history'));
		return false;
	}
	if (!in_array('css_name', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."content_navigation_history` ADD `css_name` VARCHAR( 255 ) NOT NULL DEFAULT ''";
	} else {
		$query = "ALTER TABLE `".DBPREFIX."content_navigation_history` CHANGE `css_name` `css_name` VARCHAR( 255 ) NOT NULL DEFAULT ''";
	}
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}


	////////////////////////////////////////////////////////////////////////
	// Fix (tiny/small/medium)integer keys to integer
	////////////////////////////////////////////////////////////////////////

    $query = "
    ALTER TABLE ".DBPREFIX."access_user_groups
    CHANGE COLUMN group_id group_id integer(6) UNSIGNED NOT NULL auto_increment
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."access_users
    CHANGE COLUMN id id integer(5) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN langId langId integer(2) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."backups
    CHANGE COLUMN id id integer(5) UNSIGNED NOT NULL auto_increment
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."content
    CHANGE COLUMN id id integer(6) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."content_history
    CHANGE COLUMN id id integer(8) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN page_id page_id integer(7) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."content_navigation
    CHANGE COLUMN catid catid integer(6) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN parcat parcat integer(6) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."content_navigation_history
    CHANGE COLUMN id id integer(7) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN catid catid integer(6) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN parcat parcat integer(6) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."ids
    CHANGE COLUMN id id integer(11) UNSIGNED NOT NULL auto_increment
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."languages
    CHANGE COLUMN id id integer(2) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN themesid themesid integer(2) UNSIGNED NOT NULL default '1',
    CHANGE COLUMN print_themes_id print_themes_id integer(2) UNSIGNED NOT NULL default '1'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."log
    CHANGE COLUMN id id integer(6) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN userid userid integer(6) UNSIGNED default NULL
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."skins
    CHANGE COLUMN id id integer(2) UNSIGNED NOT NULL auto_increment
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (!in_array(DBPREFIX.'settings_smtp', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."settings_smtp` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`name` VARCHAR( 50 ) NOT NULL ,
			`hostname` VARCHAR( 255 ) NOT NULL ,
			`username` VARCHAR( 255 ) NOT NULL ,
			`password` VARCHAR( 255 ) NOT NULL ,
			UNIQUE (
			`name`
			)
			) TYPE = MYISAM";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."settings_smtp");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'settings_smtp'));
		return false;
	}
	if (!in_array('port', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."settings_smtp` ADD `port` SMALLINT UNSIGNED NOT NULL DEFAULT '25' AFTER `hostname`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "
    ALTER TABLE ".DBPREFIX."module_repository
    CHANGE COLUMN id id integer(6) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN moduleid moduleid integer(5) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN parid parid integer(5) UNSIGNED NOT NULL default '0';
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

    require_once ASCMS_FRAMEWORK_PATH.'/File.class.php';
	$objFile =& new File();
	if (!is_writeable(ASCMS_PATH.ASCMS_IMAGE_PATH.'/spamprotection') && !$objFile->setChmod(ASCMS_PATH.ASCMS_IMAGE_PATH.'/spamprotection', ASCMS_IMAGE_PATH.'/spamprotection', '')) {
    	setUpdateMsg(sprintf($_ARRAYLANG['TXT_SET_WRITE_PERMISSON_TO_DIR'], ASCMS_PATH.ASCMS_IMAGE_PATH.'/spamprotection', $_CORELANG['TXT_UPDATE_TRY_AGAIN']), 'msg');
    	return false;
    }

    $arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."backups");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'backups'));
		return false;
	}
	if (!in_array('version', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."backups` ADD `version` VARCHAR( 20 ) NOT NULL DEFAULT '' AFTER `date`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('edition', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."backups` ADD `edition` VARCHAR( 30 ) NOT NULL DEFAULT '' AFTER `version`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}
	if (!in_array('type', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."backups` ADD `type` ENUM( 'sql', 'csv' ) NOT NULL DEFAULT 'sql' AFTER `edition`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	/* Alte Datenstze aktualisieren */
	$query = "UPDATE `".DBPREFIX."backups` SET `version` = '< 1.1.0', `edition` = '???' WHERE `version` = '' AND `edition` = ''";
	if ($objDatabase->Execute($query) == false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// get ids of groups who are have the access id 58
	$query = 'SELECT `group_id` FROM `'.DBPREFIX.'access_group_static_ids` WHERE `access_id` = 58';
	$objGroupIds = $objDatabase->Execute($query);
	if ($objGroupIds !== false) {
		if ($objGroupIds->RecordCount() > 0) {
			while (!$objGroupIds->EOF) {
				// check of group already has the access id 20
				$query = 'SELECT 1 FROM `'.DBPREFIX.'access_group_static_ids` WHERE `access_id` = 20 AND `group_id` = '.$objGroupIds->fields['group_id'];
				$objAccessId = $objDatabase->SelectLimit($query, 1);
				if ($objAccessId !== false) {
					if ($objAccessId->RecordCount() == 0) {
						// add access id 20 to the group
						$query = 'INSERT INTO `'.DBPREFIX.'access_group_static_ids` (`access_id`, `group_id`) VALUES (20, '. $objGroupIds->fields['group_id'].')';
						if ($objDatabase->Execute($query) === false) {
							return _databaseError($query, $objDatabase->ErrorMsg());
						}
					}
				} else {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
				$objGroupIds->MoveNext();
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = 'DELETE FROM `'.DBPREFIX.'access_group_static_ids` WHERE `access_id` = 42 OR `access_id` = 43 OR `access_id` = 44 OR `access_id` = 45 OR `access_id` = 58';
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = 'ALTER TABLE `'.DBPREFIX.'content` CHANGE `metakeys` `metakeys` TEXT NOT NULL';
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}
   	$query = 'ALTER TABLE `'.DBPREFIX.'content_history` CHANGE `metakeys` `metakeys` TEXT NOT NULL';
   	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX.'modules');
	if ($arrIndexes !== false) {
		if (!isset($arrIndexes['id'])) {
			$query = 'ALTER TABLE `'.DBPREFIX.'modules` ADD UNIQUE `id` (`id`)';
			if ($objDatabase->Execute($query) == false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'modules'));
		return false;
	}

	return true;
}

function _stripslashesFromThemes()
{
	global $objDatabase, $_CORELANG, $_ARRAYLANG, $_CONFIG, $objUpdate;

	if ($objUpdate->_isNewerVersion($_CONFIG['coreCmsVersion'], '1.1.1')) {
		$arrFileExtensions = array("htm", "shtml", "html", "txt", "css", "js", "php", "java", "tpl", "xml",);

		// get installed themes
		$query = 'SELECT themesname, foldername FROM `'.DBPREFIX.'skins`';
		$objTheme = $objDatabase->Execute($query);
		$arrThemes = array();
		if ($objTheme !== false) {
			while (!$objTheme->EOF) {
				$arrThemes[$objTheme->fields['themesname']] = $objTheme->fields['foldername'];
				$objTheme->MoveNext();
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		if (count($arrThemes)) {
			foreach ($arrThemes as $name => $path) {
				if (!isset($_SESSION['contrexx_update']['update']['update_themes'][$path])) {
					$_SESSION['contrexx_update']['update']['update_themes'][$path] = array();
				}
				$dh = @opendir(ASCMS_THEMES_PATH.'/'.$path);
				if ($dh !== false) {
					while (($file = @readdir($dh)) !== false) {
						if (preg_match('#\.([a-z]+)$#i', $file, $arrFileExtension) && in_array($arrFileExtension[1], $arrFileExtensions)) {
							if (!in_array($file, $_SESSION['contrexx_update']['update']['update_themes'][$path])) {
								$content = file_get_contents(ASCMS_THEMES_PATH.'/'.$path.'/'.$file);
						    	$fh = @fopen(ASCMS_THEMES_PATH.'/'.$path.'/'.$file, 'wb');
						    	if ($fh !== false) {
						    		$status = true;
							    	if (@fwrite($fh, stripslashes($content)) !== false) {
							    		$_SESSION['contrexx_update']['update']['update_themes'][$path][] = $file;
							    	} else {
							    		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_WRITE_FILE'], ASCMS_THEMES_PATH.'/'.$path.'/'.$file));
							    		$status = false;
							    	}
							    	@fclose($fh);

							    	if (!$status) {
							    		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_WRITE_FILE'], ASCMS_THEMES_PATH.'/'.$path.'/'.$file));
						    			setUpdateMsg(sprintf($_ARRAYLANG['TXT_SET_WRITE_PERMISSON_TO_FILE'], ASCMS_THEMES_PATH.'/'.$path.'/'.$file, $_CORELANG['TXT_UPDATE_TRY_AGAIN']), 'msg');
							    		return false;
							    	}
						    	} else {
						    		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_WRITE_FILE'], ASCMS_THEMES_PATH.'/'.$path.'/'.$file));
						    		setUpdateMsg(sprintf($_ARRAYLANG['TXT_SET_WRITE_PERMISSON_TO_FILE'], ASCMS_THEMES_PATH.'/'.$path.'/'.$file, $_CORELANG['TXT_UPDATE_TRY_AGAIN']), 'msg');
						    		return false;
						    	}
							}
						}
					}

					@closedir($dh);
				}
			}
		}
	}

	return true;
}

function _writeNewConfigurationFile($setDbCharset = false)
{
	global $_CORELANG, $_ARRAYLANG, $_DBCONFIG, $_PATHCONFIG, $_FTPCONFIG, $_CONFIGURATION;

	$ftpStatus = $_FTPCONFIG['is_activated'] ? 'true' : 'false';
	$ftpUsePassive = $_FTPCONFIG['use_passive'] ? 'true' : 'false';
	$shopJsCart = !empty($_CONFIGURATION['custom']['shopJsCart']) && $_CONFIGURATION['custom']['shopJsCart'] ? 'true' : 'false';
	$shopnavbar = !empty($_CONFIGURATION['custom']['shopnavbar']) && $_CONFIGURATION['custom']['shopnavbar'] ? 'true' : 'false';
	$dbCharset = ($setDbCharset && UPDATE_UTF8) ? 'utf8' : (!empty($_DBCONFIG['charset']) ? $_DBCONFIG['charset'] : '');
	$charset = UPDATE_UTF8 ? 'UTF-8' : 'ISO-8859-1';

	$_FTPCONFIG['port'] = intval($_FTPCONFIG['port']);

	$configurationTpl = <<<CONFIG_TPL
<?php
/**
* @exclude
*
* Contrexx CMS Web Installer
* Please use the Contrexx CMS installer to configure this file
* or edit this file and configure the parameters for your site and
* database manually.
*/

/**
* -------------------------------------------------------------------------
* Set installation status
* -------------------------------------------------------------------------
*/
define('CONTEXX_INSTALLED', true);

/**
* -------------------------------------------------------------------------
* Database configuration section
* -------------------------------------------------------------------------
*/
\$_DBCONFIG['host'] = '{$_DBCONFIG['host']}'; // This is normally set to localhost
\$_DBCONFIG['database'] = '{$_DBCONFIG['database']}'; // Database name
\$_DBCONFIG['tablePrefix'] = '{$_DBCONFIG['tablePrefix']}'; // Database table prefix
\$_DBCONFIG['user'] = '{$_DBCONFIG['user']}'; // Database username
\$_DBCONFIG['password'] = '{$_DBCONFIG['password']}'; // Database password
\$_DBCONFIG['dbType'] = '{$_DBCONFIG['dbType']}';	// Database type (e.g. mysql,postgres ..)
\$_DBCONFIG['charset'] = '{$dbCharset}'; // Charset (default, latin1, utf8, ..)

/**
* -------------------------------------------------------------------------
* Site path specific configuration
* -------------------------------------------------------------------------
*/
\$_PATHCONFIG['ascms_root'] = '{$_PATHCONFIG['ascms_root']}';
\$_PATHCONFIG['ascms_root_offset'] = '{$_PATHCONFIG['ascms_root_offset']}'; // example: '/cms';

/**
* -------------------------------------------------------------------------
* Ftp specific configuration
* -------------------------------------------------------------------------
*/
\$_FTPCONFIG['is_activated'] = {$ftpStatus}; // Ftp support true or false
\$_FTPCONFIG['use_passive'] = {$ftpUsePassive};	// Use passive ftp mode
\$_FTPCONFIG['host']	= '{$_FTPCONFIG['host']}';// This is normally set to localhost
\$_FTPCONFIG['port'] = {$_FTPCONFIG['port']}; // Ftp remote port
\$_FTPCONFIG['username'] = '{$_FTPCONFIG['username']}'; // Ftp login username
\$_FTPCONFIG['password']	= '{$_FTPCONFIG['password']}'; // Ftp login password
\$_FTPCONFIG['path']	= '{$_FTPCONFIG['path']}'; // Ftp path to cms

/**
* -------------------------------------------------------------------------
* Optional customizing exceptions
* Shopnavbar : If set to TRUE the shopnavbar will appears on each page
* -------------------------------------------------------------------------
*/
\$_CONFIGURATION['custom']['shopnavbar'] = {$shopnavbar}; // true|false
\$_CONFIGURATION['custom']['shopJsCart'] = {$shopJsCart}; // true|false

/**
* Set character encoding
*/
\$_CONFIG['coreCharacterEncoding'] = '{$charset}'; // example 'UTF-8'
@header('content-type: text/html; charset='.\$_CONFIG['coreCharacterEncoding']);

/**
* -------------------------------------------------------------------------
* Set constants
* -------------------------------------------------------------------------
*/
require_once dirname(__FILE__).'/set_constants.php';
?>
CONFIG_TPL
;

	// write settings
	if (!@include_once(ASCMS_FRAMEWORK_PATH.'/File.class.php')) {
		setUpdateMsg(sprintf($_CORELANG['TXT_UPDATE_API_LOAD_FAILED'], ASCMS_FRAMEWORK_PATH.'/File.class.php'));
		return false;
	}

	$objFile =& new File();
	$status = true;

	if (!is_writable(ASCMS_DOCUMENT_ROOT.'/config/')) {
		$objFile->setChmod(ASCMS_DOCUMENT_ROOT.'/config', ASCMS_PATH_OFFSET.'/config', '/');
	}
	if (!is_writable(ASCMS_DOCUMENT_ROOT.'/config/configuration.php')) {
		$objFile->setChmod(ASCMS_DOCUMENT_ROOT.'/config', ASCMS_PATH_OFFSET.'/config', '/configuration.php');
	}
	if (is_writable(ASCMS_DOCUMENT_ROOT.'/config/configuration.php')) {
		$handleFile = @fopen(ASCMS_DOCUMENT_ROOT.'/config/configuration.php','w+');
		if (!$handleFile) {
			setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_WRITE_SETTINGS_FILE'], ASCMS_DOCUMENT_ROOT.'/config/configuration.php'));
			setUpdateMsg(sprintf($_ARRAYLANG['TXT_SET_WRITE_PERMISSON_TO_FILE'], ASCMS_DOCUMENT_ROOT.'/config/configuration.php', $_CORELANG['TXT_UPDATE_TRY_AGAIN']), 'msg');
			return false;
		}

		@flock($handleFile, LOCK_EX); //set semaphore
		if (!@fwrite($handleFile,$configurationTpl)) {
			setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_WRITE_SETTINGS_FILE'], ASCMS_DOCUMENT_ROOT.'/config/configuration.php'));
			setUpdateMsg(sprintf($_ARRAYLANG['TXT_SET_WRITE_PERMISSON_TO_FILE'], ASCMS_DOCUMENT_ROOT.'/config/configuration.php', $_CORELANG['TXT_UPDATE_TRY_AGAIN']), 'msg');
			$status = false;
		}
		@flock($handleFile, LOCK_UN);
		@fclose($handleFile);

		return $status;
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_WRITE_SETTINGS_FILE'], ASCMS_DOCUMENT_ROOT.'/config/configuration.php'));
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_SET_WRITE_PERMISSON_TO_FILE'], ASCMS_DOCUMENT_ROOT.'/config/configuration.php', $_CORELANG['TXT_UPDATE_TRY_AGAIN']), 'msg');
		return false;
	}
}
?>
