<?php
function _aliasUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (!in_array(DBPREFIX.'module_alias_target', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_alias_target` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`type` ENUM( 'url', 'local' ) NOT NULL ,
			`url` VARCHAR( 255 ) NOT NULL ,
			UNIQUE (
				`url`
			)
			) TYPE = MYISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array(DBPREFIX.'module_alias_source', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_alias_source` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`target_id` INT UNSIGNED NOT NULL ,
			`url` VARCHAR( 255 ) NOT NULL ,
			UNIQUE (
			`url`
			)
			) TYPE = MYISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	return true;
}
?>
