<?php
function _docsysUpdate()
{
	global $objDatabase;

    $query = "
    ALTER TABLE ".DBPREFIX."module_docsys
    CHANGE COLUMN id id integer(6) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN catid catid integer(2) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN lang lang integer(2) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN userid userid integer(6) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."module_docsys_categories
    CHANGE COLUMN catid catid integer(2) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN lang lang integer(2) UNSIGNED NOT NULL default '1'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }


    $table = 'module_docsys_categories';
    $arrColumns = $objDatabase->MetaColumns(DBPREFIX.$table);
    if ($arrColumns === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.$table));
		return false;
	}

	if (empty($arrColumns['SORT_STYLE'])){
		$query = "	ALTER TABLE `".DBPREFIX."$table`
					ADD `sort_style`
						ENUM( 'alpha', 'date', 'date_alpha' )
						NOT NULL DEFAULT 'alpha'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}
    return true;
}
?>
